Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision b4c9c61b6d2be7f3de7f313e31fc7ad751b286ba)
+++ uspace/srv/net/il/ip/ip.c	(revision fdbc3ff84ed86b1d20bebbe6c6235ecc5954f606)
@@ -139,10 +139,10 @@
  * Searches the registered protocols.
  *
- * @returns		The found ICMP phone.
- * @returns		ENOENT if the ICMP is not registered.
+ * @return		The found ICMP phone.
+ * @return		ENOENT if the ICMP is not registered.
  */
 static int ip_get_icmp_phone(void)
 {
-	ip_proto_ref proto;
+	ip_proto_t *proto;
 	int phone;
 
@@ -160,15 +160,15 @@
  * @param[in] packet	The packet or the packet queue to be reported as faulty.
  * @param[in] header	The first packet IP header. May be NULL.
- * @returns		EOK on success.
- * @returns		EINVAL if there are no data in the packet.
- * @returns		EINVAL if the packet is a fragment.
- * @returns		ENOMEM if the packet is too short to contain the IP
+ * @return		EOK on success.
+ * @return		EINVAL if there are no data in the packet.
+ * @return		EINVAL if the packet is a fragment.
+ * @return		ENOMEM if the packet is too short to contain the IP
  *			header.
- * @returns		EAFNOSUPPORT if the address family is not supported.
- * @returns		EPERM if the protocol is not allowed to send ICMP
+ * @return		EAFNOSUPPORT if the address family is not supported.
+ * @return		EPERM if the protocol is not allowed to send ICMP
  *			notifications. The ICMP protocol itself.
- * @returns		Other error codes as defined for the packet_set_addr().
- */
-static int ip_prepare_icmp(packet_t packet, ip_header_ref header)
+ * @return		Other error codes as defined for the packet_set_addr().
+ */
+static int ip_prepare_icmp(packet_t packet, ip_header_t *header)
 {
 	packet_t next;
@@ -187,5 +187,5 @@
 
 		// get header
-		header = (ip_header_ref) packet_get_data(packet);
+		header = (ip_header_t *) packet_get_data(packet);
 		if (!header)
 			return EINVAL;
@@ -227,12 +227,12 @@
  * @param[in] packet	The packet or the packet queue to be reported as faulty.
  * @param[in] header	The first packet IP header. May be NULL.
- * @returns		The found ICMP phone.
- * @returns		EINVAL if the error parameter is set.
- * @returns		EINVAL if the ICMP phone is not found.
- * @returns		EINVAL if the ip_prepare_icmp() fails.
+ * @return		The found ICMP phone.
+ * @return		EINVAL if the error parameter is set.
+ * @return		EINVAL if the ICMP phone is not found.
+ * @return		EINVAL if the ip_prepare_icmp() fails.
  */
 static int
 ip_prepare_icmp_and_get_phone(services_t error, packet_t packet,
-    ip_header_ref header)
+    ip_header_t *header)
 {
 	int phone;
@@ -248,6 +248,6 @@
  * @param[in] client_connection The client connection processing function. The
  *			module skeleton propagates its own one.
- * @returns		EOK on success.
- * @returns		ENOMEM if there is not enough memory left.
+ * @return		EOK on success.
+ * @return		ENOMEM if there is not enough memory left.
  */
 int ip_initialize(async_client_conn_t client_connection)
@@ -293,20 +293,20 @@
  *
  * @param[in,out] ip_netif Network interface specific data.
- * @returns		EOK on success.
- * @returns		ENOTSUP if DHCP is configured.
- * @returns		ENOTSUP if IPv6 is configured.
- * @returns		EINVAL if any of the addresses is invalid.
- * @returns		EINVAL if the used ARP module is not known.
- * @returns		ENOMEM if there is not enough memory left.
- * @returns		Other error codes as defined for the
+ * @return		EOK on success.
+ * @return		ENOTSUP if DHCP is configured.
+ * @return		ENOTSUP if IPv6 is configured.
+ * @return		EINVAL if any of the addresses is invalid.
+ * @return		EINVAL if the used ARP module is not known.
+ * @return		ENOMEM if there is not enough memory left.
+ * @return		Other error codes as defined for the
  *			net_get_device_conf_req() function.
- * @returns		Other error codes as defined for the bind_service()
+ * @return		Other error codes as defined for the bind_service()
  *			function.
- * @returns		Other error codes as defined for the specific
+ * @return		Other error codes as defined for the specific
  *			arp_device_req() function.
- * @returns		Other error codes as defined for the
+ * @return		Other error codes as defined for the
  *			nil_packet_size_req() function.
  */
-static int ip_netif_initialize(ip_netif_ref ip_netif)
+static int ip_netif_initialize(ip_netif_t *ip_netif)
 {
 	measured_string_t names[] = {
@@ -344,9 +344,9 @@
 		}
 	};
-	measured_string_ref configuration;
+	measured_string_t *configuration;
 	size_t count = sizeof(names) / sizeof(measured_string_t);
 	char *data;
 	measured_string_t address;
-	ip_route_ref route;
+	ip_route_t *route;
 	in_addr_t gateway;
 	int index;
@@ -378,5 +378,5 @@
 			return ENOTSUP;
 		} else if (ip_netif->ipv == IPV4) {
-			route = (ip_route_ref) malloc(sizeof(ip_route_t));
+			route = (ip_route_t *) malloc(sizeof(ip_route_t));
 			if (!route) {
 				net_free_settings(configuration, data);
@@ -486,10 +486,10 @@
  * @param[in] device_id	The device identifier.
  * @param[in] mtu	The new mtu value.
- * @returns		EOK on success.
- * @returns		ENOENT if device is not found.
+ * @return		EOK on success.
+ * @return		ENOENT if device is not found.
  */
 static int ip_mtu_changed_message(device_id_t device_id, size_t mtu)
 {
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -511,10 +511,10 @@
  * @param[in] device_id	The device identifier.
  * @param[in] state	The new state value.
- * @returns		EOK on success.
- * @returns		ENOENT if device is not found.
+ * @return		EOK on success.
+ * @return		ENOENT if device is not found.
  */
 static int ip_device_state_message(device_id_t device_id, device_state_t state)
 {
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -539,13 +539,13 @@
  * @param[in] packet	The packet to be prefixed.
  * @param[in] last	The last header to be copied.
- * @returns		The prefixed middle header.
- * @returns		NULL on error.
- */
-static ip_header_ref
-ip_create_middle_header(packet_t packet, ip_header_ref last)
-{
-	ip_header_ref middle;
-
-	middle = (ip_header_ref) packet_suffix(packet, IP_HEADER_LENGTH(last));
+ * @return		The prefixed middle header.
+ * @return		NULL on error.
+ */
+static ip_header_t *
+ip_create_middle_header(packet_t packet, ip_header_t *last)
+{
+	ip_header_t *middle;
+
+	middle = (ip_header_t *) packet_suffix(packet, IP_HEADER_LENGTH(last));
 	if (!middle)
 		return NULL;
@@ -562,7 +562,7 @@
  * @param[in] first	The original header to be copied.
  */
-static void ip_create_last_header(ip_header_ref last, ip_header_ref first)
-{
-	ip_option_ref option;
+static void ip_create_last_header(ip_header_t *last, ip_header_t *first)
+{
+	ip_option_t *option;
 	size_t next;
 	size_t length;
@@ -575,5 +575,5 @@
 	// process all ip options
 	while (next < first->header_length) {
-		option = (ip_option_ref) (((uint8_t *) first) + next);
+		option = (ip_option_t *) (((uint8_t *) first) + next);
 		// skip end or noop
 		if ((option->type == IPOPT_END) ||
@@ -613,20 +613,20 @@
  * @param[in,out] packet The packet to be sent.
  * @param[in] destination The destination hardware address.
- * @returns		EOK on success.
- * @returns		EINVAL if the packet is too small to contain the IP
+ * @return		EOK on success.
+ * @return		EINVAL if the packet is too small to contain the IP
  *			header.
- * @returns		EINVAL if the packet is too long than the IP allows.
- * @returns		ENOMEM if there is not enough memory left.
- * @returns		Other error codes as defined for the packet_set_addr()
+ * @return		EINVAL if the packet is too long than the IP allows.
+ * @return		ENOMEM if there is not enough memory left.
+ * @return		Other error codes as defined for the packet_set_addr()
  *			function.
  */
 static int
 ip_prepare_packet(in_addr_t *source, in_addr_t dest, packet_t packet,
-    measured_string_ref destination)
+    measured_string_t *destination)
 {
 	size_t length;
-	ip_header_ref header;
-	ip_header_ref last_header;
-	ip_header_ref middle_header;
+	ip_header_t *header;
+	ip_header_t *last_header;
+	ip_header_t *middle_header;
 	packet_t next;
 	int rc;
@@ -636,5 +636,5 @@
 		return EINVAL;
 
-	header = (ip_header_ref) packet_get_data(packet);
+	header = (ip_header_t *) packet_get_data(packet);
 	if (destination) {
 		rc = packet_set_addr(packet, NULL, (uint8_t *) destination->value,
@@ -660,5 +660,5 @@
 
 	if (pq_next(packet)) {
-		last_header = (ip_header_ref) malloc(IP_HEADER_LENGTH(header));
+		last_header = (ip_header_t *) malloc(IP_HEADER_LENGTH(header));
 		if (!last_header)
 			return ENOMEM;
@@ -666,5 +666,5 @@
 		next = pq_next(packet);
 		while (pq_next(next)) {
-			middle_header = (ip_header_ref) packet_prefix(next,
+			middle_header = (ip_header_t *) packet_prefix(next,
 			    IP_HEADER_LENGTH(last_header));
 			if (!middle_header) {
@@ -698,5 +698,5 @@
 		}
 
-		middle_header = (ip_header_ref) packet_prefix(next,
+		middle_header = (ip_header_t *) packet_prefix(next,
 		    IP_HEADER_LENGTH(last_header));
 		if (!middle_header) {
@@ -746,14 +746,14 @@
  * @param[in] dest	The destiantion address.
  * @param[in] addrlen	The address length.
- * @returns		EOK on success.
- * @returns		ENOMEM if the target packet is too small.
- * @returns		Other error codes as defined for the packet_set_addr()
+ * @return		EOK on success.
+ * @return		ENOMEM if the target packet is too small.
+ * @return		Other error codes as defined for the packet_set_addr()
  *			function.
- * @returns		Other error codes as defined for the pq_insert_after()
+ * @return		Other error codes as defined for the pq_insert_after()
  *			function.
  */
 static int
 ip_fragment_packet_data(packet_t packet, packet_t new_packet,
-    ip_header_ref header, ip_header_ref new_header, size_t length,
+    ip_header_t *header, ip_header_t *new_header, size_t length,
     const struct sockaddr *src, const struct sockaddr *dest, socklen_t addrlen)
 {
@@ -799,18 +799,18 @@
  * @param[in] suffix	The minimum suffix size.
  * @param[in] addr_len	The minimum address length.
- * @returns		EOK on success.
- * @returns		EINVAL if the packet_get_addr() function fails.
- * @returns		EINVAL if the packet does not contain the IP header.
- * @returns		EPERM if the packet needs to be fragmented and the
+ * @return		EOK on success.
+ * @return		EINVAL if the packet_get_addr() function fails.
+ * @return		EINVAL if the packet does not contain the IP header.
+ * @return		EPERM if the packet needs to be fragmented and the
  *			fragmentation is not allowed.
- * @returns		ENOMEM if there is not enough memory left.
- * @returns		ENOMEM if there is no packet available.
- * @returns		ENOMEM if the packet is too small to contain the IP
+ * @return		ENOMEM if there is not enough memory left.
+ * @return		ENOMEM if there is no packet available.
+ * @return		ENOMEM if the packet is too small to contain the IP
  *			header.
- * @returns		Other error codes as defined for the packet_trim()
+ * @return		Other error codes as defined for the packet_trim()
  *			function.
- * @returns		Other error codes as defined for the
+ * @return		Other error codes as defined for the
  *			ip_create_middle_header() function.
- * @returns		Other error codes as defined for the
+ * @return		Other error codes as defined for the
  *			ip_fragment_packet_data() function.
  */
@@ -820,7 +820,7 @@
 {
 	packet_t new_packet;
-	ip_header_ref header;
-	ip_header_ref middle_header;
-	ip_header_ref last_header;
+	ip_header_t *header;
+	ip_header_t *middle_header;
+	ip_header_t *last_header;
 	struct sockaddr *src;
 	struct sockaddr *dest;
@@ -838,5 +838,5 @@
 
 	// get header
-	header = (ip_header_ref) packet_get_data(packet);
+	header = (ip_header_t *) packet_get_data(packet);
 	if (!header)
 		return EINVAL;
@@ -853,5 +853,5 @@
 
 	// allocate as much as originally
-	last_header = (ip_header_ref) packet_suffix(new_packet,
+	last_header = (ip_header_t *) packet_suffix(new_packet,
 	    IP_HEADER_LENGTH(header));
 	if (!last_header)
@@ -919,6 +919,6 @@
  * @param[in] addr_len	The minimum address length.
  * @param[in] error	The error module service.
- * @returns		The packet or the packet queue of the allowed length.
- * @returns		NULL if there are no packets left.
+ * @return		The packet or the packet queue of the allowed length.
+ * @return		NULL if there are no packets left.
  */
 static packet_t
@@ -986,16 +986,16 @@
  * @param[in] dest	The destination address.
  * @param[in] error	The error module service.
- * @returns		EOK on success.
- * @returns		Other error codes as defined for the arp_translate_req()
+ * @return		EOK on success.
+ * @return		Other error codes as defined for the arp_translate_req()
  *			function.
- * @returns		Other error codes as defined for the ip_prepare_packet()
+ * @return		Other error codes as defined for the ip_prepare_packet()
  *			function.
  */
 static int
-ip_send_route(packet_t packet, ip_netif_ref netif, ip_route_ref route,
+ip_send_route(packet_t packet, ip_netif_t *netif, ip_route_t *route,
     in_addr_t *src, in_addr_t dest, services_t error)
 {
 	measured_string_t destination;
-	measured_string_ref translation;
+	measured_string_t *translation;
 	char *data;
 	int phone;
@@ -1062,12 +1062,12 @@
  *			NULL.
  * @param[in] destination The destination address.
- * @returns		The found route.
- * @returns		NULL if no route was found.
- */
-static ip_route_ref
-ip_netif_find_route(ip_netif_ref netif, in_addr_t destination)
+ * @return		The found route.
+ * @return		NULL if no route was found.
+ */
+static ip_route_t *
+ip_netif_find_route(ip_netif_t *netif, in_addr_t destination)
 {
 	int index;
-	ip_route_ref route;
+	ip_route_t *route;
 
 	if (!netif)
@@ -1090,11 +1090,11 @@
  *
  * @param[in] destination The destination address.
- * @returns		The found route.
- * @returns		NULL if no route was found.
- */
-static ip_route_ref ip_find_route(in_addr_t destination) {
+ * @return		The found route.
+ * @return		NULL if no route was found.
+ */
+static ip_route_t *ip_find_route(in_addr_t destination) {
 	int index;
-	ip_route_ref route;
-	ip_netif_ref netif;
+	ip_route_t *route;
+	ip_netif_t *netif;
 
 	// start with the last netif - the newest one
@@ -1116,10 +1116,10 @@
  *
  * @param[in] netif	The network interface.
- * @returns		The IP address.
- * @returns		NULL if no IP address was found.
- */
-static in_addr_t *ip_netif_address(ip_netif_ref netif)
-{
-	ip_route_ref route;
+ * @return		The IP address.
+ * @return		NULL if no IP address was found.
+ */
+static in_addr_t *ip_netif_address(ip_netif_t *netif)
+{
+	ip_route_t *route;
 
 	route = ip_routes_get_index(&netif->routes, 0);
@@ -1136,10 +1136,10 @@
  * @param[in] phone	The transport layer module phone.
  * @param[in] received_msg The receiving function.
- * @returns		EOK on success.
- * @returns		EINVAL if the protocol parameter and/or the service
+ * @return		EOK on success.
+ * @return		EINVAL if the protocol parameter and/or the service
  *			parameter is zero.
- * @returns		EINVAL if the phone parameter is not a positive number
+ * @return		EINVAL if the phone parameter is not a positive number
  *			and the tl_receive_msg is NULL.
- * @returns		ENOMEM if there is not enough memory left.
+ * @return		ENOMEM if there is not enough memory left.
  */
 static int
@@ -1147,5 +1147,5 @@
     tl_received_msg_t received_msg)
 {
-	ip_proto_ref proto;
+	ip_proto_t *proto;
 	int index;
 
@@ -1153,5 +1153,5 @@
 		return EINVAL;
 
-	proto = (ip_proto_ref) malloc(sizeof(ip_protos_t));
+	proto = (ip_proto_t *) malloc(sizeof(ip_protos_t));
 	if (!proto)
 		return ENOMEM;
@@ -1180,10 +1180,10 @@
 ip_device_req_local(int il_phone, device_id_t device_id, services_t netif)
 {
-	ip_netif_ref ip_netif;
-	ip_route_ref route;
+	ip_netif_t *ip_netif;
+	ip_route_t *route;
 	int index;
 	int rc;
 
-	ip_netif = (ip_netif_ref) malloc(sizeof(ip_netif_t));
+	ip_netif = (ip_netif_t *) malloc(sizeof(ip_netif_t));
 	if (!ip_netif)
 		return ENOMEM;
@@ -1251,6 +1251,6 @@
 {
 	int addrlen;
-	ip_netif_ref netif;
-	ip_route_ref route;
+	ip_netif_t *netif;
+	ip_route_t *route;
 	struct sockaddr *addr;
 	struct sockaddr_in *address_in;
@@ -1361,5 +1361,5 @@
  * @param[out] content	The maximum content size.
  * @param[out] suffix	The minimum reserved suffix size.
- * @returns		EOK on success.
+ * @return		EOK on success.
  */
 static int
@@ -1367,5 +1367,5 @@
     size_t *content, size_t *suffix)
 {
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 	int index;
 
@@ -1418,7 +1418,7 @@
  *
  * @param[in] header	The packet IP header to be read.
- * @returns		The packet destination address.
- */
-static in_addr_t ip_get_destination(ip_header_ref header)
+ * @return		The packet destination address.
+ */
+static in_addr_t ip_get_destination(ip_header_t *header)
 {
 	in_addr_t destination;
@@ -1439,20 +1439,20 @@
  * @param[in] header	The first packet IP header. May be NULL.
  * @param[in] error	The packet error service.
- * @returns		EOK on success.
- * @returns		ENOTSUP if the packet is a fragment.
- * @returns		EAFNOSUPPORT if the address family is not supported.
- * @returns		ENOENT if the target protocol is not found.
- * @returns		Other error codes as defined for the packet_set_addr()
+ * @return		EOK on success.
+ * @return		ENOTSUP if the packet is a fragment.
+ * @return		EAFNOSUPPORT if the address family is not supported.
+ * @return		ENOENT if the target protocol is not found.
+ * @return		Other error codes as defined for the packet_set_addr()
  *			function.
- * @returns		Other error codes as defined for the packet_trim()
+ * @return		Other error codes as defined for the packet_trim()
  *			function.
- * @returns		Other error codes as defined for the protocol specific
+ * @return		Other error codes as defined for the protocol specific
  *			tl_received_msg() function.
  */
 static int
-ip_deliver_local(device_id_t device_id, packet_t packet, ip_header_ref header,
+ip_deliver_local(device_id_t device_id, packet_t packet, ip_header_t *header,
     services_t error)
 {
-	ip_proto_ref proto;
+	ip_proto_t *proto;
 	int phone;
 	services_t service;
@@ -1544,10 +1544,10 @@
  * @param[in] device_id	The source device identifier.
  * @param[in] packet	The received packet to be processed.
- * @returns		EOK on success.
- * @returns		EINVAL if the TTL is less than two.
- * @returns		EINVAL if the checksum is invalid.
- * @returns		EAFNOSUPPORT if the address family is not supported.
- * @returns		ENOENT if no route was found.
- * @returns		ENOENT if the packet is for another host and the routing
+ * @return		EOK on success.
+ * @return		EINVAL if the TTL is less than two.
+ * @return		EINVAL if the checksum is invalid.
+ * @return		EAFNOSUPPORT if the address family is not supported.
+ * @return		ENOENT if no route was found.
+ * @return		ENOENT if the packet is for another host and the routing
  *			is disabled.
  */
@@ -1555,7 +1555,7 @@
 ip_process_packet(device_id_t device_id, packet_t packet)
 {
-	ip_header_ref header;
+	ip_header_t *header;
 	in_addr_t dest;
-	ip_route_ref route;
+	ip_route_t *route;
 	int phone;
 	struct sockaddr *addr;
@@ -1564,5 +1564,5 @@
 	int rc;
 
-	header = (ip_header_ref) packet_get_data(packet);
+	header = (ip_header_t *) packet_get_data(packet);
 	if (!header)
 		return ip_release_and_return(packet, ENOMEM);
@@ -1647,6 +1647,6 @@
     in_addr_t netmask, in_addr_t gateway)
 {
-	ip_route_ref route;
-	ip_netif_ref netif;
+	ip_route_t *route;
+	ip_netif_t *netif;
 	int index;
 
@@ -1659,5 +1659,5 @@
 	}
 
-	route = (ip_route_ref) malloc(sizeof(ip_route_t));
+	route = (ip_route_t *) malloc(sizeof(ip_route_t));
 	if (!route) {
 		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
@@ -1681,5 +1681,5 @@
 ip_set_gateway_req_local(int ip_phone, device_id_t device_id, in_addr_t gateway)
 {
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
@@ -1721,8 +1721,8 @@
 	icmp_type_t type;
 	icmp_code_t code;
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 	measured_string_t address;
-	ip_route_ref route;
-	ip_header_ref header;
+	ip_route_t *route;
+	ip_header_t *header;
 
 	switch (error) {
@@ -1734,5 +1734,5 @@
 
 		data = packet_get_data(packet);
-		header = (ip_header_ref)(data + offset);
+		header = (ip_header_t *)(data + offset);
 
 		// destination host unreachable?
@@ -1782,6 +1782,6 @@
 	in_addr_t *dest;
 	in_addr_t *src;
-	ip_route_ref route;
-	ipv4_pseudo_header_ref header_in;
+	ip_route_t *route;
+	ipv4_pseudo_header_t *header_in;
 
 	if (!destination || (addrlen <= 0))
@@ -1829,5 +1829,5 @@
 
 	*headerlen = sizeof(*header_in);
-	header_in = (ipv4_pseudo_header_ref) malloc(*headerlen);
+	header_in = (ipv4_pseudo_header_t *) malloc(*headerlen);
 	if (!header_in)
 		return ENOMEM;
@@ -1849,13 +1849,13 @@
  * @param[in] device_id	The source device identifier.
  * @param[in,out] packet The received packet.
- * @returns		EOK on success and the packet is no longer needed.
- * @returns		EINVAL if the packet is too small to carry the IP
+ * @return		EOK on success and the packet is no longer needed.
+ * @return		EINVAL if the packet is too small to carry the IP
  *			packet.
- * @returns		EINVAL if the received address lengths differs from the
+ * @return		EINVAL if the received address lengths differs from the
  *			registered values.
- * @returns		ENOENT if the device is not found in the cache.
- * @returns		ENOENT if the protocol for the device is not found in
+ * @return		ENOENT if the device is not found in the cache.
+ * @return		ENOENT if the protocol for the device is not found in
  *			the cache.
- * @returns		ENOMEM if there is not enough memory left.
+ * @return		ENOMEM if there is not enough memory left.
  */
 static int ip_receive_message(device_id_t device_id, packet_t packet)
@@ -1879,6 +1879,6 @@
  * @param[out] answer_count The last parameter for the actual answer in the
  *			answer parameter.
- * @returns		EOK on success.
- * @returns		ENOTSUP if the message is not known.
+ * @return		EOK on success.
+ * @return		ENOTSUP if the message is not known.
  *
  * @see ip_interface.h
@@ -2037,6 +2037,6 @@
 /** Starts the module.
  *
- * @returns EOK on success.
- * @returns Other error codes as defined for each specific module start function.
+ * @return EOK on success.
+ * @return Other error codes as defined for each specific module start function.
  */
 int main(int argc, char *argv[])
Index: uspace/srv/net/il/ip/ip.h
===================================================================
--- uspace/srv/net/il/ip/ip.h	(revision b4c9c61b6d2be7f3de7f313e31fc7ad751b286ba)
+++ uspace/srv/net/il/ip/ip.h	(revision fdbc3ff84ed86b1d20bebbe6c6235ecc5954f606)
@@ -59,9 +59,4 @@
 typedef struct ip_netif ip_netif_t;
 
-/** Type definition of the IP network interface specific data pointer.
- * @see ip_netif
- */
-typedef ip_netif_t *ip_netif_ref;
-
 /** Type definition of the IP protocol specific data.
  * @see ip_proto
@@ -69,18 +64,8 @@
 typedef struct ip_proto ip_proto_t;
 
-/** Type definition of the IP protocol specific data pointer.
- * @see ip_proto
- */
-typedef ip_proto_t *ip_proto_ref;
-
 /** Type definition of the IP route specific data.
  *  @see ip_route
  */
 typedef struct ip_route	ip_route_t;
-
-/** Type definition of the IP route specific data pointer.
- *  @see ip_route
- */
-typedef ip_route_t *ip_route_ref;
 
 /** IP network interfaces.
@@ -104,5 +89,5 @@
 struct ip_netif {
 	/** ARP module. Assigned if using ARP. */
-	module_ref arp;
+	module_t *arp;
 	/** Broadcast address. */
 	in_addr_t broadcast;
@@ -146,5 +131,5 @@
 	in_addr_t gateway;
 	/** Parent netif. */
-	ip_netif_ref netif;
+	ip_netif_t *netif;
 	/** Target network mask. */
 	in_addr_t netmask;
Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision b4c9c61b6d2be7f3de7f313e31fc7ad751b286ba)
+++ uspace/srv/net/net/net.c	(revision fdbc3ff84ed86b1d20bebbe6c6235ecc5954f606)
@@ -78,4 +78,6 @@
 DEVICE_MAP_IMPLEMENT(netifs, netif_t);
 
+static int startup(void);
+
 /** Add the configured setting to the configuration map.
  *
@@ -84,14 +86,14 @@
  * @param[in] value         The setting value.
  *
- * @returns EOK on success.
- * @returns ENOMEM if there is not enough memory left.
- *
- */
-int add_configuration(measured_strings_ref configuration, const char *name,
+ * @return EOK on success.
+ * @return ENOMEM if there is not enough memory left.
+ *
+ */
+int add_configuration(measured_strings_t *configuration, const char *name,
     const char *value)
 {
 	int rc;
 	
-	measured_string_ref setting =
+	measured_string_t *setting =
 	    measured_string_create_bulk(value, 0);
 	if (!setting)
@@ -110,5 +112,5 @@
 /** Generate new system-unique device identifier.
  *
- * @returns		The system-unique devic identifier.
+ * @return		The system-unique devic identifier.
  */
 static device_id_t generate_new_device_id(void)
@@ -117,5 +119,5 @@
 }
 
-static int parse_line(measured_strings_ref configuration, char *line)
+static int parse_line(measured_strings_t *configuration, char *line)
 {
 	int rc;
@@ -163,5 +165,5 @@
 	
 	/* Create a bulk measured string till the end */
-	measured_string_ref setting =
+	measured_string_t *setting =
 	    measured_string_create_bulk(value, 0);
 	if (!setting)
@@ -179,5 +181,5 @@
 
 static int read_configuration_file(const char *directory, const char *filename,
-    measured_strings_ref configuration)
+    measured_strings_t *configuration)
 {
 	printf("%s: Reading configuration file %s/%s\n", NAME, directory, filename);
@@ -235,6 +237,6 @@
  * @param[in,out] netif The network interface structure.
  *
- * @returns EOK on success.
- * @returns Other error codes as defined for the add_configuration() function.
+ * @return EOK on success.
+ * @return Other error codes as defined for the add_configuration() function.
  *
  */
@@ -246,6 +248,6 @@
 /** Read the networking subsystem global configuration.
  *
- * @returns EOK on success.
- * @returns Other error codes as defined for the add_configuration() function.
+ * @return EOK on success.
+ * @return Other error codes as defined for the add_configuration() function.
  *
  */
@@ -262,6 +264,6 @@
  *                              its own one.
  *
- * @returns EOK on success.
- * @returns ENOMEM if there is not enough memory left.
+ * @return EOK on success.
+ * @return ENOMEM if there is not enough memory left.
  *
  */
@@ -313,7 +315,7 @@
  *                              its own one.
  *
- * @returns EOK on successful module termination.
- * @returns Other error codes as defined for the net_initialize() function.
- * @returns Other error codes as defined for the REGISTER_ME() macro function.
+ * @return EOK on successful module termination.
+ * @return Other error codes as defined for the net_initialize() function.
+ * @return Other error codes as defined for the REGISTER_ME() macro function.
  *
  */
@@ -337,4 +339,9 @@
 		goto out;
 	
+	rc = startup();
+	if (rc != EOK)
+		goto out;
+	
+	task_retval(0);
 	async_manager();
 
@@ -353,9 +360,9 @@
  * @param[out] data          The found configuration settings data.
  *
- * @returns EOK.
- *
- */
-static int net_get_conf(measured_strings_ref netif_conf,
-    measured_string_ref configuration, size_t count, char **data)
+ * @return EOK.
+ *
+ */
+static int net_get_conf(measured_strings_t *netif_conf,
+    measured_string_t *configuration, size_t count, char **data)
 {
 	if (data)
@@ -364,5 +371,5 @@
 	size_t index;
 	for (index = 0; index < count; index++) {
-		measured_string_ref setting =
+		measured_string_t *setting =
 		    measured_strings_find(netif_conf, configuration[index].value, 0);
 		if (!setting)
@@ -382,5 +389,5 @@
 }
 
-int net_get_conf_req(int net_phone, measured_string_ref *configuration,
+int net_get_conf_req(int net_phone, measured_string_t **configuration,
     size_t count, char **data)
 {
@@ -392,5 +399,5 @@
 
 int net_get_device_conf_req(int net_phone, device_id_t device_id,
-    measured_string_ref *configuration, size_t count, char **data)
+    measured_string_t **configuration, size_t count, char **data)
 {
 	if ((!configuration) || (count == 0))
@@ -404,5 +411,5 @@
 }
 
-void net_free_settings(measured_string_ref settings, char *data)
+void net_free_settings(measured_string_t *settings, char *data)
 {
 }
@@ -415,11 +422,11 @@
  * @param[in] netif The network interface specific data.
  *
- * @returns EOK on success.
- * @returns EINVAL if there are some settings missing.
- * @returns ENOENT if the internet protocol module is not known.
- * @returns Other error codes as defined for the netif_probe_req() function.
- * @returns Other error codes as defined for the nil_device_req() function.
- * @returns Other error codes as defined for the needed internet layer
- *          registering function.
+ * @return EOK on success.
+ * @return EINVAL if there are some settings missing.
+ * @return ENOENT if the internet protocol module is not known.
+ * @return Other error codes as defined for the netif_probe_req() function.
+ * @return Other error codes as defined for the nil_device_req() function.
+ * @return Other error codes as defined for the needed internet layer
+ *         registering function.
  *
  */
@@ -429,5 +436,5 @@
 	
 	/* Mandatory netif */
-	measured_string_ref setting =
+	measured_string_t *setting =
 	    measured_strings_find(&netif->configuration, CONF_NETIF, 0);
 	
@@ -507,13 +514,13 @@
 /** Read the configuration and start all network interfaces.
  *
- * @returns EOK on success.
- * @returns EXDEV if there is no available system-unique device identifier.
- * @returns EINVAL if any of the network interface names are not configured.
- * @returns ENOMEM if there is not enough memory left.
- * @returns Other error codes as defined for the read_configuration()
- *          function.
- * @returns Other error codes as defined for the read_netif_configuration()
- *          function.
- * @returns Other error codes as defined for the start_device() function.
+ * @return EOK on success.
+ * @return EXDEV if there is no available system-unique device identifier.
+ * @return EINVAL if any of the network interface names are not configured.
+ * @return ENOMEM if there is not enough memory left.
+ * @return Other error codes as defined for the read_configuration()
+ *         function.
+ * @return Other error codes as defined for the read_netif_configuration()
+ *         function.
+ * @return Other error codes as defined for the start_device() function.
  *
  */
@@ -550,5 +557,5 @@
 		
 		/* Mandatory name */
-		measured_string_ref setting =
+		measured_string_t *setting =
 		    measured_strings_find(&netif->configuration, CONF_NAME, 0);
 		if (!setting) {
@@ -610,6 +617,6 @@
  *                          in the answer parameter.
  *
- * @returns EOK on success.
- * @returns ENOTSUP if the message is not known.
+ * @return EOK on success.
+ * @return ENOTSUP if the message is not known.
  *
  * @see net_interface.h
@@ -620,5 +627,5 @@
     int *answer_count)
 {
-	measured_string_ref strings;
+	measured_string_t *strings;
 	char *data;
 	int rc;
